from api import *

casesInf=[]
# Fonction appelée au début de la partie.
def partie_init():
    global casesInf
    casesInf = [] #C'est ici la liste des cases desquelles on ne peut sortir (culs-de-sac)
    #On parcourt chaue case de la carte et on verifie si c'est une case inaccessible, et on l'ajoute a la liste
    for ligne in range(HAUTEUR):
        for colonne in range(LARGEUR):
            if info_case((colonne, ligne, 0)).contenu==type_case.BUISSON or info_barriere((colonne,ligne, 0))==etat_barriere.FERMEE:
                casesInf.append((colonne,ligne,0))
    #On parcourt a nouveau les cases, et si elle ne sont pas deja dans la liste, on verifie si elle a 3 voisines ou plus inaccessible. C'est alors un cul de sac, et on l'ajoute a la liste.
    for ligne in range(1,HAUTEUR-1):
        for colonne in range(1,LARGEUR-1):
            nbAdj=0
            if (colonne, ligne, 0) not in casesInf :
                if (colonne+1, ligne, 0) in casesInf :
                    nbAdj+=1
                if (colonne-1, ligne, 0) in casesInf :
                    nbAdj+=1
                if (colonne, ligne+1, 0) in casesInf :
                    nbAdj+=1 
                if (colonne, ligne-1, 0) in casesInf :
                    nbAdj+=1
                if nbAdj>=3:
                    casesInf.append((colonne,ligne,0))
    #On effectue cela a nouveau pour reperer les culs de sac de profondeur de 2 cases.
    for ligne in range(1,HAUTEUR-1):
        for colonne in range(1,LARGEUR-1):
            nbAdj=0
            if (colonne, ligne, 0) not in casesInf :
                if (colonne+1, ligne, 0) in casesInf :
                    nbAdj+=1
                if (colonne-1, ligne, 0) in casesInf :
                    nbAdj+=1
                if (colonne, ligne+1, 0) in casesInf :
                    nbAdj+=1 
                if (colonne, ligne-1, 0) in casesInf :
                    nbAdj+=1
                if nbAdj>=3:
                    casesInf.append((colonne,ligne,0))




# Fonction appelée à chaque tour.
def jouer_tour():
    global casesInf
    #Determine si je suis joueur 1 ou 2 pour la suite
    if moi()==0:
        nidM=etat_nid.JOUEUR_0
    else:
        nidM=etat_nid.JOUEUR_1

    def posCanards(): #fonction qui permet de recuperer la liste de toutes les positions des canards 
        listeCanards=[]
        for canard in troupes_joueur(moi())[0].canards:
            listeCanards.append(canard)
        for canard in troupes_joueur(moi())[1].canards:
            listeCanards.append(canard)
        for canard in troupes_joueur(adversaire())[0].canards:
            listeCanards.append(canard)
        for canard in troupes_joueur(adversaire())[1].canards:
            listeCanards.append(canard)
        return listeCanards

    #debug_poser_pigeon(troupes_joueur(moi())[0].maman,pigeon_debug.PIGEON_BLEU)

    #On repere tous les nids vides, puis les deux troupes se dirigent vers le nid libre le plus proche.
    coordMaman1 = troupes_joueur(moi())[0].maman #position maman troupe 1
    test=0 #variable pour determiner si il reste des nids libres
    best=float('inf')
    for ligne in range(HAUTEUR):
        for colonne in range(LARGEUR): 
            if info_nid((colonne,ligne,0))==etat_nid.LIBRE :
                if len(trouver_chemin((colonne, ligne, 0),coordMaman1))<best and len(trouver_chemin(coordMaman1,(colonne, ligne, 0)))!=0 and (colonne,ligne,0) not in posCanards():
                    best=len(trouver_chemin(coordMaman1,(colonne, ligne, 0)))
                    meilleurNid = (colonne,ligne,0)
    if best != float('inf'): #ie si un nid a ete trouve
        for dir in trouver_chemin(coordMaman1,meilleurNid):
            avancer(troupes_joueur(moi())[0].id, dir)
        test=1
    #idem pour la troupe 2
    coordMaman2 = troupes_joueur(moi())[1].maman #position maman troupe 2
    test=0
    best=float('inf')
    for ligne in range(HAUTEUR):
        for colonne in range(LARGEUR): 
            if info_nid((colonne,ligne,0))==etat_nid.LIBRE :
                if len(trouver_chemin((colonne, ligne, 0),coordMaman2))<best and len(trouver_chemin(coordMaman2,(colonne, ligne, 0)))!=0 and (colonne,ligne,0) not in posCanards():
                    best=len(trouver_chemin(coordMaman2,(colonne, ligne, 0)))
                    meilleurNid = (colonne,ligne,0)
    if best != float('inf'):
        for dir in trouver_chemin(coordMaman2,meilleurNid):
            avancer(troupes_joueur(moi())[1].id, dir)
        test=1
    ############################################################################
    ######## Grandir a chaque tour avec une limite de taille max de 30 #########
    ############################################################################
    if test==0: #On ne grandit que si tous les nids sont occuppes
        if troupes_joueur(moi())[0].taille<30: #Pour la troupe 1
            grandir(troupes_joueur(moi())[0].id) 
        if troupes_joueur(moi())[1].taille<30: #Pour la troupe 2
            grandir(troupes_joueur(moi())[1].id)

    ##########################
    ######## Troupe 1 ########
    ##########################
    coordMaman1 = troupes_joueur(moi())[0].maman #position maman troupe 1
    if troupes_joueur(moi())[0].inventaire>=10 or tour_actuel()>390: #Si l'inventaire est plein ou si le match est presque fini, la cible est le nid le plus proche.
        nids=[] #liste des nids possibles
        for ligne in range(HAUTEUR):
            for colonne in range(LARGEUR): #on parcourt les cases pour construire cette liste.
                if info_nid((colonne,ligne,0))==etat_nid.LIBRE or info_nid((colonne,ligne,0))==nidM:
                    nids.append((colonne,ligne,0))
        #On determine de la meme facon que precedemment le nid le plus proche            
        best = float('inf') 
        meilleurNid=None          
        for nid in nids:
            if len(trouver_chemin(coordMaman1,nid))<best and nid not in posCanards() and len(trouver_chemin(coordMaman1,nid))!=0:
                best=len(trouver_chemin(coordMaman1,nid))
                meilleurNid=nid
        #la troupe se deplace vers ce nid, s'il existe
        if best != float('inf'):
            for dir in trouver_chemin(coordMaman1,meilleurNid):
                avancer(troupes_joueur(moi())[0].id, dir)
    #sinon, la troupe repere le pain le plus proche            
    else :
        best=float('inf')
        meilleurPain = None
        for pain in pains():
            if len(trouver_chemin(coordMaman1,pain))<best and pain not in posCanards() and len(trouver_chemin(coordMaman1,pain))!=0:
                best=len(trouver_chemin(coordMaman1,pain))
                meilleurPain = pain
        #elle se rapproche de ce pain, s'il existe
        if best != float('inf'):
            for dir in trouver_chemin(coordMaman1,meilleurPain):
                avancer(troupes_joueur(moi())[0].id, dir)

    #Ensuite, la troupe doit consommer ses eventuels points d'action restants
    while troupes_joueur(moi())[0].pts_action>0: #tant qu'il lui en reste
        coordMaman1 = troupes_joueur(moi())[0].maman #position maman troupe 1
        #Ces 4premiers cas determinent si la maman se situe a un point S au bord de la carte. Dans ce cas, il n'y a qu'un deplacement possible.
        if troupes_joueur(moi())[0].maman[0]==0:
            avancer(troupes_joueur(moi())[0].id, direction.EST)
        elif troupes_joueur(moi())[0].maman[0]==LARGEUR-1:
            avancer(troupes_joueur(moi())[0].id, direction.OUEST)     
        elif troupes_joueur(moi())[0].maman[1]==0:
            avancer(troupes_joueur(moi())[0].id, direction.NORD)          
        elif troupes_joueur(moi())[0].maman[1]==HAUTEUR-1:
            avancer(troupes_joueur(moi())[0].id, direction.SUD)
        #Ces 4 suivants determinent dans les autres cas si la case a cote (un cas par direction) n'est ni un buisson, ni une barriere fermee, ni un autre canard, ni un cul-de-sac. Si c'est bon, elle se deplace vers cette case.
        elif info_case((coordMaman1[0]+1,coordMaman1[1],0)).contenu!=type_case.BUISSON and info_barriere((coordMaman1[0]+1,coordMaman1[1],0))!=etat_barriere.FERMEE and info_case((coordMaman1[0]+1,coordMaman1[1],0)).contenu not in posCanards() and troupes_joueur(moi())[0].canards[1]!=(coordMaman1[0]+1,coordMaman1[1],0) and (coordMaman1[0]+1,coordMaman1[1],0) not in casesInf:
            avancer(troupes_joueur(moi())[0].id, direction.EST)
        elif info_case((coordMaman1[0]-1,coordMaman1[1],0)).contenu!=type_case.BUISSON and info_barriere((coordMaman1[0]-1,coordMaman1[1],0))!=etat_barriere.FERMEE and info_case((coordMaman1[0]-1,coordMaman1[1],0)).contenu not in posCanards() and troupes_joueur(moi())[0].canards[1]!=(coordMaman1[0]-1,coordMaman1[1],0) and (coordMaman1[0]+1,coordMaman1[1],0) not in casesInf:
            avancer(troupes_joueur(moi())[0].id, direction.OUEST)
        elif info_case((coordMaman1[0],coordMaman1[1]+1,0)).contenu!=type_case.BUISSON and info_barriere((coordMaman1[0],coordMaman1[1]+1,0))!=etat_barriere.FERMEE and info_case((coordMaman1[0],coordMaman1[1]+1,0)).contenu not in posCanards() and troupes_joueur(moi())[0].canards[1]!=(coordMaman1[0],coordMaman1[1]+1,0) and (coordMaman1[0]+1,coordMaman1[1],0) not in casesInf:
            avancer(troupes_joueur(moi())[0].id, direction.NORD)
        elif info_case((coordMaman1[0],coordMaman1[1]-1,0)).contenu!=type_case.BUISSON and info_barriere((coordMaman1[0],coordMaman1[1]-1,0))!=etat_barriere.FERMEE and info_case((coordMaman1[0],coordMaman1[1]-1,0)).contenu not in posCanards() and troupes_joueur(moi())[0].canards[1]!=(coordMaman1[0],coordMaman1[1]-1,0) and (coordMaman1[0]+1,coordMaman1[1],0) not in casesInf:
            avancer(troupes_joueur(moi())[0].id, direction.SUD)
        #Si aucune case n'est valable, il vaut mieux interrompre la boucle et laisser la troupe se cogner plutot que de faire un time out.    
        else :
            break

    ##########################
    ######## Troupe 2 ########
    ##########################
    #Le fonctionnement est exactement identique pour la troupe 2
    coordMaman2 = troupes_joueur(moi())[1].maman #position maman troupe 2
    if troupes_joueur(moi())[1].inventaire>=10 or tour_actuel()>390:
        #print('recherche nid')
        nids=[]
        for ligne in range(HAUTEUR):
            for colonne in range(LARGEUR): 
                if info_nid((colonne,ligne,0))==etat_nid.LIBRE or info_nid((colonne,ligne,0))==nidM:
                    nids.append((colonne,ligne,0))
        best = float('inf') 
        meilleurNid=None          
        for nid in nids:
            if len(trouver_chemin(coordMaman2,nid))<best and nid not in posCanards() and len(trouver_chemin(coordMaman2,nid))!=0:
                best=len(trouver_chemin(coordMaman2,nid))
                meilleurNid=nid
        if best != float('inf'):
            for dir in trouver_chemin(coordMaman2,meilleurNid):
                avancer(troupes_joueur(moi())[1].id, dir)
    else :
        best=float('inf')
        meilleurPain = None
        for pain in pains():
            if len(trouver_chemin(coordMaman2,pain))<best and pain not in posCanards() and len(trouver_chemin(coordMaman2,pain))!=0:
                best=len(trouver_chemin(coordMaman2,pain))
                meilleurPain = pain
        if best != float('inf'):
            for dir in trouver_chemin(coordMaman2,meilleurPain):
                avancer(troupes_joueur(moi())[1].id, dir)
    while troupes_joueur(moi())[1].pts_action>0:
        coordMaman2 = troupes_joueur(moi())[1].maman #position maman troupe 2
        if troupes_joueur(moi())[1].maman[0]==0:
            avancer(troupes_joueur(moi())[1].id, direction.EST)
        elif troupes_joueur(moi())[1].maman[0]==LARGEUR-1:
            avancer(troupes_joueur(moi())[1].id, direction.OUEST)     
        elif troupes_joueur(moi())[1].maman[1]==0:
            avancer(troupes_joueur(moi())[1].id, direction.NORD)           
        elif troupes_joueur(moi())[1].maman[1]==HAUTEUR-1:
            avancer(troupes_joueur(moi())[1].id, direction.SUD)
        elif info_case((coordMaman2[0]+1,coordMaman2[1],0)).contenu!=type_case.BUISSON and info_barriere((coordMaman2[0]+1,coordMaman2[1],0))!=etat_barriere.FERMEE and info_case((coordMaman2[0]+1,coordMaman2[1],0)).contenu not in posCanards() and troupes_joueur(moi())[1].canards[1]!=(coordMaman2[0]+1,coordMaman2[1],0) and (coordMaman2[0]+1,coordMaman2[1],0) not in casesInf:
            avancer(troupes_joueur(moi())[1].id, direction.EST)
        elif info_case((coordMaman2[0]-1,coordMaman2[1],0)).contenu!=type_case.BUISSON and info_barriere((coordMaman2[0]-1,coordMaman2[1],0))!=etat_barriere.FERMEE and info_case((coordMaman2[0]-1,coordMaman2[1],0)).contenu not in posCanards() and troupes_joueur(moi())[1].canards[1]!=(coordMaman2[0]-1,coordMaman2[1],0) and (coordMaman2[0]+1,coordMaman2[1],0) not in casesInf:
            avancer(troupes_joueur(moi())[1].id, direction.OUEST)
        elif info_case((coordMaman2[0],coordMaman2[1]+1,0)).contenu!=type_case.BUISSON and info_barriere((coordMaman2[0],coordMaman2[1]+1,0))!=etat_barriere.FERMEE and info_case((coordMaman2[0],coordMaman2[1]+1,0)).contenu not in posCanards() and troupes_joueur(moi())[1].canards[1]!=(coordMaman2[0],coordMaman2[1]+1,0) and (coordMaman2[0]+1,coordMaman2[1],0) not in casesInf:
            avancer(troupes_joueur(moi())[1].id, direction.NORD)
        elif info_case((coordMaman2[0],coordMaman2[1]-1,0)).contenu!=type_case.BUISSON and info_barriere((coordMaman2[0],coordMaman2[1]-1,0))!=etat_barriere.FERMEE and info_case((coordMaman2[0],coordMaman2[1]-1,0)).contenu not in posCanards() and troupes_joueur(moi())[1].canards[1]!=(coordMaman2[0],coordMaman2[1]-1,0) and (coordMaman2[0]+1,coordMaman2[1],0) not in casesInf:
            avancer(troupes_joueur(moi())[1].id, direction.SUD)
        else :
            break
        


      

# Fonction appelée à la fin de la partie.
def partie_fin():
    pass







'''
if info_case(tuple([coordMaman1[0]+1,coordMaman1[1],0])).contenu==type_case.GAZON:
    avancer(troupes_joueur(moi())[0].id, direction.OUEST)
if info_case(tuple([coordMaman1[0],coordMaman1[1]+1,0])).contenu==type_case.GAZON:
    avancer(troupes_joueur(moi())[0].id, direction.NORD)
if info_case(tuple([coordMaman1[0]-1,coordMaman1[1],0])).contenu==type_case.GAZON:
    avancer(troupes_joueur(moi())[0].id, direction.EST)
if info_case(tuple([coordMaman1[0],coordMaman1[1]-1,0])).contenu==type_case.GAZON:    
    avancer(troupes_joueur(moi())[0].id, direction.SUD)
'''
'''
nids=[]
for ligne in range(HAUTEUR):
    for colonne in range(LARGEUR): 
        if info_nid((colonne,ligne,0))==etat_nid.LIBRE:
            nids.append((colonne,ligne,0))
print(nids)
best=float('inf')
print(coordMaman1)
print(trouver_chemin(coordMaman1,nids[2]))
for nid in nids:
    if len(trouver_chemin(coordMaman1,nid))<best and len(trouver_chemin(coordMaman1,nid))!=0:
        best=nid
print(best)
if best!=float('inf'):
    for direction in trouver_chemin(coordMaman1,best):
        avancer(troupes_joueur(moi())[0].id, direction)
    del nids[nids.index(best)]

print(pains())
for pain in pains():
    if trouver_chemin(coordMaman1,pain)!=[]:
        print(trouver_chemin(coordMaman1,pain))
        for dir in trouver_chemin(coordMaman1,pain):
            avancer(troupes_joueur(moi())[0].id, dir)
    break
'''



'''
if info_case((colonne,ligne, 0)).contenu!=type_case.BUISSON and info_barriere((colonne,ligne, 0))!=etat_barriere.FERMEE:
    if info_case((colonne+1,ligne, 0)).contenu!=type_case.BUISSON and info_barriere((colonne+1,ligne, 0))!=etat_barriere.FERMEE:
        pass
    if info_case((colonne-1,ligne, 0)).contenu!=type_case.BUISSON and info_barriere((colonne-1,ligne, 0))!=etat_barriere.FERMEE:
        pass
    if info_case((colonne,ligne+1, 0)).contenu!=type_case.BUISSON and info_barriere((colonne,ligne+1, 0))!=etat_barriere.FERMEE:
        pass
    if info_case((colonne,ligne-1, 0)).contenu!=type_case.BUISSON and info_barriere((colonne,ligne-1, 0))!=etat_barriere.FERMEE:
        pass
'''



'''
if troupes_joueur(moi())[1].inventaire>=7:
    nids=[]
    for ligne in range(HAUTEUR):
        for colonne in range(LARGEUR): 
            if info_nid((colonne,ligne,0))==etat_nid.LIBRE:
                nids.append((colonne,ligne,0))
    best = float('inf') 
    meilleurNid=None           
    for nid in nids():
        if len(trouver_chemin(coordMaman2,nid))<best:
            best=len(trouver_chemin(coordMaman2,nid))
            meilleurNid=nid
    if best != float('inf'):
        for dir in trouver_chemin(coordMaman2,meilleurNid):
            avancer(troupes_joueur(moi())[1].id, dir)
else :
    best=float('inf')
    meilleurPain = None
    for pain in pains():
        if len(trouver_chemin(coordMaman2,pain))<best:
            best=len(trouver_chemin(coordMaman2,pain))
            meilleurPain = pain
    if best != float('inf'):
                    for dir in trouver_chemin(coordMaman2,meilleurPain):
avancer(troupes_joueur(moi())[1].id, dir)

'''

'''

derDir = None
for i in range(2):
    if troupes_joueur(moi())[1].inventaire>=7:
        nids=[]
        for ligne in range(HAUTEUR):
            for colonne in range(LARGEUR): 
                if info_nid((colonne,ligne,0))==etat_nid.LIBRE or info_nid((colonne,ligne,0))==nidM:
                    nids.append((colonne,ligne,0))
        best = float('inf') 
        meilleurNid=None          
        for nid in nids:
            if len(trouver_chemin(coordMaman2,nid))<best and nid not in posCanards():
                best=len(trouver_chemin(coordMaman2,nid))
                meilleurNid=nid
        if best != float('inf'):
            for dir in trouver_chemin(coordMaman2,meilleurNid):
                avancer(troupes_joueur(moi())[1].id, dir)
                derDir = dir
    else :
        best=float('inf')
        meilleurPain = None
        for pain in pains():
            if len(trouver_chemin(coordMaman2,pain))<best and pain not in posCanards():
                best=len(trouver_chemin(coordMaman2,pain))
                meilleurPain = pain
        if best != float('inf'):
            for dir in trouver_chemin(coordMaman2,meilleurPain):
                avancer(troupes_joueur(moi())[1].id, dir)
                derDir=dir

'''
'''
best=float('inf')
for pain in pains():
    if len(trouver_chemin(coordMaman1,pain))<best:
        best=len(trouver_chemin(coordMaman1,pain))
if best != float('inf'):
    for dir in trouver_chemin(coordMaman1,pain):
        avancer(troupes_joueur(moi())[0].id, dir)

best=float('inf')
for pain in pains():
    if len(trouver_chemin(coordMaman2,pain))<best:
        best=len(trouver_chemin(coordMaman2,pain))
if best != float('inf'):
    for dir in trouver_chemin(coordMaman2,pain):
        avancer(troupes_joueur(moi())[1].id, dir)
'''

   
'''
global graphe={}
for ligne in range(HAUTEUR):
    for colonne in range(LARGEUR):
        graphe[(colonne,ligne, 0)]=[]
        if info_case((colonne,ligne, 0)).contenu!=type_case.BUISSON and info_barriere((colonne,ligne, 0))!=etat_barriere.FERMEE:
            if colonne == 0 : #ligne ne peut etre egal a 0 ou hauteur
                if info_case((colonne+1,ligne, 0)).contenu!=type_case.BUISSON and info_barriere((colonne+1,ligne, 0))!=etat_barriere.FERMEE:
                    graphe[(colonne,ligne, 0)].append((colonne+1,ligne, 0))  
            elif colonne == LARGEUR-1:
                if info_case((colonne-1,ligne, 0)).contenu!=type_case.BUISSON and info_barriere((colonne-1,ligne, 0))!=etat_barriere.FERMEE:
                    graphe[(colonne,ligne, 0)].append((colonne-1,ligne, 0))
            elif ligne == 0:
                if info_case((colonne,ligne+1, 0)).contenu!=type_case.BUISSON and info_barriere((colonne,ligne+1, 0))!=etat_barriere.FERMEE:
                    graphe[(colonne,ligne, 0)].append((colonne,ligne+1, 0))
            elif ligne == HAUTEUR-1:
                if info_case((colonne,ligne-1, 0)).contenu!=type_case.BUISSON and info_barriere((colonne,ligne-1, 0))!=etat_barriere.FERMEE:
                    graphe[(colonne,ligne, 0)].append((colonne,ligne-1, 0))
            else :
                if info_case((colonne+1,ligne, 0)).contenu!=type_case.BUISSON and info_barriere((colonne+1,ligne, 0))!=etat_barriere.FERMEE:
                    graphe[(colonne,ligne, 0)].append((colonne+1,ligne, 0))
                if info_case((colonne-1,ligne, 0)).contenu!=type_case.BUISSON and info_barriere((colonne-1,ligne, 0))!=etat_barriere.FERMEE:
                    graphe[(colonne,ligne, 0)].append((colonne-1,ligne, 0))
                if info_case((colonne,ligne+1, 0)).contenu!=type_case.BUISSON and info_barriere((colonne,ligne+1, 0))!=etat_barriere.FERMEE:
                    graphe[(colonne,ligne, 0)].append((colonne,ligne+1, 0))
                if info_case((colonne,ligne-1, 0)).contenu!=type_case.BUISSON and info_barriere((colonne,ligne-1, 0))!=etat_barriere.FERMEE:
                    graphe[(colonne,ligne, 0)].append((colonne,ligne-1, 0))
print(graphe)
'''

'''
if troupes_joueur(moi())[0].maman[0]==0:
    avancer(troupes_joueur(moi())[0].id, direction.EST)
    derDir = direction.EST
elif troupes_joueur(moi())[0].maman[0]==LARGEUR-1:
    avancer(troupes_joueur(moi())[0].id, direction.OUEST)
    derDir = direction.OUEST        
elif troupes_joueur(moi())[0].maman[1]==0:
    avancer(troupes_joueur(moi())[0].id, direction.NORD)
    derDir = direction.NORD            
elif troupes_joueur(moi())[0].maman[1]==HAUTEUR-1:
    avancer(troupes_joueur(moi())[0].id, direction.SUD)
    derDir = direction.SUD
'''